SystemOrganization addCategory: #'Tp1-TADP'!
SystemOrganization addCategory: #'Tp1-TADP-Test'!

Trait named: #NoPoceado
	uses: {}
	category: 'Tp1-TADP'!

Trait named: #Poceado
	uses: {}
	category: 'Tp1-TADP'!

TestCase subclass: #Testeador
	instanceVariableNames: 'bruno quini6 apostaConMarta apuesta loto quini pagaLaPutaMadre prodeGanaRiver agenciaPirulo jugada sorteo bruna altaJugada nano unaJugada otraJugada teddy laAgenciaDeChola pancho quiniela losHijosDePuta'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp1-TADP-Test'!

!Testeador methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/7/2012 15:05'!
testApuestaInicialLoto
	agenciaPirulo := Agencia new.
	loto := Loto new.
	bruno := Timbero new.
	
	bruno initialize.
	loto initialize.
	agenciaPirulo initialize.
	
	bruno armarApuestaDe: loto con: #(4 8 15 16 23 42) para: agenciaPirulo con: 2.
	bruno jugar.
	
	sorteo := Sorteo new.
	sorteo initialize.
	sorteo sorteame: #(4 8 15 16 23 42) alJuego: loto.
	self assert: agenciaPirulo caja equals: ((2*12/100)+((2*40/100)*5/100))! !

!Testeador methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/7/2012 15:22'!
testApuestaInicialPagaOPaga

teddy := Timbero new.
laAgenciaDeChola := Agencia new.
pagaLaPutaMadre := PagaOPaga new.
sorteo := Sorteo new.

teddy initialize.
laAgenciaDeChola initialize.
pagaLaPutaMadre initialize.
sorteo initialize.

teddy armarApuestaDe: pagaLaPutaMadre con: #(1 24 21 73 84 52 16 7 27 72 54 12 94 90 43) para: laAgenciaDeChola con: 15.

"Aca no le pega a ningun numero"
sorteo sorteame: #(0 2 3 4 5 6 8 9 10 11 13 14 15 17 18) alJuego: pagaLaPutaMadre.
self assert: laAgenciaDeChola caja equals: 0.

"Aca le pega a todos"
sorteo sorteame: #(1 24 21 73 84 52 16 7 27 72 54 12 94 90 43) alJuego: pagaLaPutaMadre.
self assert: laAgenciaDeChola caja equals: (405/8)*(10/100).
! !

!Testeador methodsFor: 'as yet unclassified' stamp: 'pdanibenitez 9/7/2012 17:41'!
testApuestaInicialQuiniela

pancho := Timbero new.
losHijosDePuta := Agencia new.
quiniela := Quiniela new.
sorteo := Sorteo new.

pancho initialize.
losHijosDePuta initialize.
quiniela initialize.
sorteo initialize.

pancho armarApuestaDe: quiniela con: #(55 10) para: losHijosDePuta con: 100.

"Aca no le pega a ningun numero"
sorteo sorteame: #(0 2 3 10 43 12 84 999 102 383 545 146 728 82 75 25 82 94 66 3333) alJuego: quiniela.
self assert: losHijosDePuta caja equals: 17.
self assert: pancho ganancia equals: 0.

"Aca le pega a todos"
sorteo sorteame: #(1 2 3 4 5 6 7 8 9 55 11 12 13 14 15 16 17 18 19 20) alJuego: quiniela.
self assert: losHijosDePuta caja equals: 17.
! !

Object subclass: #Agencia
	instanceVariableNames: 'caja aPagar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp1-TADP'!

!Agencia methodsFor: 'accessing' stamp: 'MarianoGerman 9/7/2012 13:57'!
aPagar
	^ aPagar! !

!Agencia methodsFor: 'accessing' stamp: 'MarianoGerman 9/7/2012 14:04'!
aPagar: anObject
	aPagar add: anObject.! !

!Agencia methodsFor: 'accessing' stamp: 'MarianoGerman 9/7/2012 12:01'!
caja
	^ caja! !

!Agencia methodsFor: 'accessing' stamp: 'MarianoGerman 9/7/2012 12:01'!
caja: anObject
	caja := anObject! !

!Agencia methodsFor: 'accessing' stamp: 'MarianoGerman 9/7/2012 12:02'!
ganaste: plata 
	self caja: caja + plata.! !

!Agencia methodsFor: 'accessing' stamp: 'MarianoGerman 9/7/2012 14:03'!
initialize 
	self caja: 0.
	aPagar := OrderedCollection new..! !

!Agencia methodsFor: 'accessing' stamp: 'MarianoGerman 9/7/2012 14:09'!
pagale: pago
	self aPagar: pago.! !

Object subclass: #Apuesta
	instanceVariableNames: 'juego jugada agencia monto jugador'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp1-TADP'!

!Apuesta methodsFor: 'accessing' stamp: 'pdanibenitez 9/6/2012 15:27'!
agencia
	^ agencia! !

!Apuesta methodsFor: 'accessing' stamp: 'pdanibenitez 9/6/2012 15:27'!
agencia: anObject
	agencia := anObject! !

!Apuesta methodsFor: 'accessing' stamp: 'pdanibenitez 9/6/2012 15:27'!
juego
	^ juego! !

!Apuesta methodsFor: 'accessing' stamp: 'pdanibenitez 9/6/2012 15:27'!
juego: anObject
	juego := anObject! !

!Apuesta methodsFor: 'accessing' stamp: 'pdanibenitez 9/6/2012 15:27'!
jugada
	^ jugada! !

!Apuesta methodsFor: 'accessing' stamp: 'pdanibenitez 9/6/2012 15:27'!
jugada: anObject
	jugada := anObject! !

!Apuesta methodsFor: 'accessing' stamp: 'MarianoGerman 9/7/2012 14:08'!
jugador
	^ jugador! !

!Apuesta methodsFor: 'accessing' stamp: 'MarianoGerman 9/7/2012 14:08'!
jugador: anObject
	jugador := anObject! !

!Apuesta methodsFor: 'accessing' stamp: 'pdanibenitez 9/6/2012 15:27'!
monto
	^ monto! !

!Apuesta methodsFor: 'accessing' stamp: 'pdanibenitez 9/6/2012 15:27'!
monto: anObject
	monto := anObject! !

!Apuesta methodsFor: 'accessing' stamp: 'MarianoGerman 9/7/2012 13:45'!
sosGanadora: jugadaGanadora 
	^self jugada allSatisfy:[:unNumero | jugada includes: unNumero].! !

Object subclass: #Juego
	instanceVariableNames: 'apuestasEnJuego'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp1-TADP'!

!Juego methodsFor: 'as yet unclassified' stamp: 'GuidoWagner 9/6/2012 18:08'!
apuestasEnJuego
	^ apuestasEnJuego.! !

!Juego methodsFor: 'as yet unclassified' stamp: 'GuidoWagner 9/6/2012 18:10'!
initialize 			
	apuestasEnJuego := OrderedCollection new.
		
		! !

!Juego methodsFor: 'as yet unclassified' stamp: 'GuidoWagner 9/6/2012 18:08'!
recibiApuesta: apuesta
	self apuestasEnJuego add: apuesta! !

Juego subclass: #Loto
	uses: Poceado
	instanceVariableNames: 'pozo porcentaje6Aciertos porcentajeParaAgenciaGanadora porcentajeParaJugadas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp1-TADP'!

Loto class
	uses: Poceado classTrait
	instanceVariableNames: ''!

!Loto methodsFor: 'as yet unclassified' stamp: 'MarianoGerman 9/7/2012 17:17'!
cuantoRobaLaAgencia: coleccionGanadores 
	^(self loQueLeCorrespondeAcadaGanador:coleccionGanadores)*porcentajeParaAgenciaGanadora
! !

!Loto methodsFor: 'as yet unclassified' stamp: 'MarianoGerman 9/7/2012 17:22'!
initialize 
	   super initialize.
	   self porcentaje6Aciertos: 0.4.
	   self porcentajeParaAgenciaGanadora: 0.05.
	   self porcentajeParaJugadas: 0.12.
	! !

!Loto methodsFor: 'as yet unclassified' stamp: 'MarianoGerman 9/7/2012 17:16'!
loQueLeCorrespondeAcadaGanador: coleccionGanadores 
	^((pozo*porcentaje6Aciertos)/(coleccionGanadores size))! !

!Loto methodsFor: 'accessing' stamp: 'MarianoGerman 9/7/2012 17:05'!
porcentaje6Aciertos
	^ porcentaje6Aciertos! !

!Loto methodsFor: 'accessing' stamp: 'MarianoGerman 9/7/2012 17:05'!
porcentaje6Aciertos: anObject
	porcentaje6Aciertos := anObject! !

!Loto methodsFor: 'accessing' stamp: 'MarianoGerman 9/7/2012 17:11'!
porcentajeParaAgenciaGanadora
	^ porcentajeParaAgenciaGanadora! !

!Loto methodsFor: 'accessing' stamp: 'MarianoGerman 9/7/2012 17:11'!
porcentajeParaAgenciaGanadora: anObject
	porcentajeParaAgenciaGanadora := anObject! !

!Loto methodsFor: 'accessing' stamp: 'MarianoGerman 9/7/2012 17:22'!
porcentajeParaJugadas
	^ porcentajeParaJugadas! !

!Loto methodsFor: 'accessing' stamp: 'MarianoGerman 9/7/2012 17:22'!
porcentajeParaJugadas: anObject
	porcentajeParaJugadas := anObject! !

!Loto methodsFor: 'accessing' stamp: 'MarianoGerman 9/7/2012 13:01'!
pozo
	^ pozo! !

!Loto methodsFor: 'accessing' stamp: 'MarianoGerman 9/7/2012 13:01'!
pozo: anObject
	pozo := anObject! !

!Loto methodsFor: 'as yet unclassified' stamp: 'MarianoGerman 9/7/2012 17:23'!
tomaGanadora: jugadaGanadora 
     | coleccionGanadores plataParaAgencia plataParaJugador |

	self pozo: apuestasEnJuego size * 2.
	
	"Las agencias ganan el 12% de las jugadas realiadas en ellas"
	apuestasEnJuego do:[:apuest | apuest agencia ganaste: (apuest monto*porcentajeParaJugadas)].  
	
	"coleccion de ganadores con 6 aciertos"	
	coleccionGanadores := apuestasEnJuego select:[:apuesta | apuesta sosGanadora: jugadaGanadora]. 
	
	plataParaAgencia := self cuantoRobaLaAgencia: coleccionGanadores.
	plataParaJugador := self loQueLeCorrespondeAcadaGanador: coleccionGanadores.
	
	"Le pago a la agencia el 5% y le digo que le page al timbero ganador el 40% del pozo (dividido la cantidad de ganadores)"
	coleccionGanadores do:[:apuestaG | (apuestaG agencia ganaste: plataParaAgencia). (apuestaG agencia aPagar: #(plataParaJugador  (apuestaG jugador)))].
	
	

! !

Juego subclass: #PagaOPaga
	uses: NoPoceado
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp1-TADP'!

PagaOPaga class
	uses: NoPoceado classTrait
	instanceVariableNames: ''!

Juego subclass: #Prode
	uses: Poceado
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp1-TADP'!

Prode class
	uses: Poceado classTrait
	instanceVariableNames: ''!

Juego subclass: #Quiniela
	uses: NoPoceado
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp1-TADP'!

Quiniela class
	uses: NoPoceado classTrait
	instanceVariableNames: ''!

!Quiniela methodsFor: 'as yet unclassified' stamp: 'pdanibenitez 9/7/2012 17:32'!
tomaGanadora: jugadaGanadora 
	
	"Las agencias ganan el 17% de las jugadas realiadas en ellas"
	apuestasEnJuego do:[:ap | ap agencia ganaste: (ap monto*17/100)].  
! !

Object subclass: #Sorteo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp1-TADP'!

!Sorteo methodsFor: 'as yet unclassified' stamp: 'MarianoGerman 9/7/2012 12:05'!
initialize 
	apuestasLoto := OrderedCollection new.
	apuestasQuiniela  := OrderedCollection new.
	apuestasPoP  := OrderedCollection new.
	apuestasProde  := OrderedCollection new.
					! !

!Sorteo methodsFor: 'as yet unclassified' stamp: 'MarianoGerman 9/7/2012 12:22'!
sorteame: jugadaGanadora alJuego: juego
	juego tomaGanadora: jugadaGanadora .! !

Object subclass: #Timbero
	instanceVariableNames: 'apuestas ganancia'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp1-TADP'!

!Timbero methodsFor: 'accessing' stamp: 'pdanibenitez 9/6/2012 15:01'!
apuestas
	^ apuestas! !

!Timbero methodsFor: 'accessing' stamp: 'MarianoGerman 9/7/2012 14:08'!
armarApuestaDe: unJuego con: unaJugada para: unaAgencia con: unMonto
	| unaApuesta |
	
	unaApuesta := Apuesta new.
	unaApuesta juego: unJuego.
	unaApuesta jugada: unaJugada.
	unaApuesta agencia: unaAgencia.
	unaApuesta monto: unMonto.
	unaApuesta jugador: self.
	
	self apuestas add: unaApuesta.
	
	! !

!Timbero methodsFor: 'accessing' stamp: 'pdanibenitez 9/7/2012 17:41'!
ganancia 
	^ ganancia ! !

!Timbero methodsFor: 'accessing' stamp: 'pdanibenitez 9/7/2012 17:43'!
ganaste: unaCantidad
	self ganancia = self ganancia + unaCantidad  ! !

!Timbero methodsFor: 'as yet unclassified' stamp: 'pdanibenitez 9/7/2012 17:43'!
initialize 
	super initialize. 
	apuestas := OrderedCollection new.
	self ganancia = 0.


	! !

!Timbero methodsFor: 'accessing' stamp: 'GuidoWagner 9/6/2012 17:44'!
jugar
	self apuestas do:[ :apuesta | apuesta juego recibiApuesta: apuesta ].! !
